%{
#include <ctype.h>
#include <stdio.h>
int yyparse(void);
int yylex(void);
%}

%token NUMBER
%token PLUS
%token MINUS
%token NEWLINE

%%

lines
    :    /* prazna linija */
    |    lines NEWLINE
    |    lines e NEWLINE           { printf("%d\n\n", $2); }
    |    lines error NEWLINE       { yyerror("reenter last line:\n");
                                     yyerrok; }
    ;

e
    :    e PLUS NUMBER             { $$ = $1 + $3; }
    |    e MINUS NUMBER            { $$ = $1 - $3; }
    |    NUMBER                    { $$ = $1; }
    ;

%%

int main() {
    return yyparse();
}

int yyerror(char *s) {
    fprintf(stderr, "%s\n", s);
    return 0;
}
