%{
#include <ctype.h>
#include <stdio.h>
int yyparse(void);
int yylex(void);
%}

%token NUMBER
%token PLUS
%token MINUS
%token MULTIPLY
%token DIVIDE
%token NEWLINE

%left  PLUS MINUS
%left  MULTIPLY DIVIDE
%right UMINUS

%%

lines
    :    /* prazna linija */
    |    lines NEWLINE
    |    lines e NEWLINE         { printf("%d\n", $2); }
    ;

e
    :    e PLUS e                { $$ = $1 + $3; }
    |    e MINUS e               { $$ = $1 - $3; }
    |    e MULTIPLY e            { $$ = $1 * $3; }
    |    e DIVIDE e              { $$ = $1 / $3; }
    |    MINUS e %prec UMINUS    { $$ = -$2; }
    |    NUMBER                  { $$ = $1; }
    ;

%%

int main() {
    return yyparse();
}

int yyerror(char *s) {
    fprintf(stderr, "%s\n", s);
    return 0;
}
