
#ifndef CODEGEN_H
#define CODEGEN_H

#include "defs.h"

void indent(bool tabs);

int  take_reg(void);
void free_reg(void);
void release_reg(int reg_index);

// generise labelu koja se sastoji od 2 stringa npr: main_exit
// prefix = TRUE da bi se ispisao '@' ispred labele, u suprotnom je FALSE
void gen_str_lab(char *str1, char *str2, bool prefix);

// generise labelu koja se sastoji od jednog stringa i jednog broja npr: if0
// prefix = TRUE da bi se ispisao '@' ispred labele, u suprotnom je FALSE
void gen_num_lab(char *str, int num, bool prefix);


// generise jump na labelu koja se sastoji od 2 stringa
void gen_jump_to_str_lab(char *jmp, char *str1, char *str2, bool prefix);

// generise jump na labelu koja se sastoji od jednog stringa i jednog broja
void gen_jump_to_num_lab(char *jmp, char *str, int num, bool prefix);

// ispisuje simbol (u odgovarajucem obliku) koji se nalazi na datom indeksu u tabeli simbola
void print_symbol(int index);


// generise CMP naredbu, parametri su indeksi operanada u TS-a 
void gen_cmp(int operand1_index, int operand2_index);

// generise MOV naredbu, parametri su indeksi operanada u TS-a 
void gen_mov(int input_index, int output_index);

// generise naredbe ADD, SUB, MUL ili DIV
// prvi parametar je jedna od konstanti ADD_OP, SUB_OP, MUL_OP ili DIV_OP
// drugi i treci parametar su indeksi operanada u TS-a 
int gen_arith(int statement, int operand1_index, int operand2_index);


void gen_function_call(int name_index);
void gen_clear_loc_var(int num);
void gen_push(int arg_index);
void gen_reg_save();
void gen_reg_restore();

#endif
