
#include <stdlib.h>
#include <stdio.h>
#include "stack.h"
#include "defs.h"

// sp se krece od vecih ka manjim indeksima
// sp pokazuje na poslednju popunjenu lokaciju

void push(stack *s, int val) {
    if(s->sp == 0) {
        syyerror("Compiler error! Stack overflow!");
        exit(EXIT_FAILURE);
    }
    s->values[--s->sp] = val;
}

int pop(stack *s) {
    if(s->sp >= STACK_SIZE) {
        syyerror("Compiler error! Stack underflow!");
        exit(EXIT_FAILURE);
    }
    return s->values[s->sp++];
}

int top(stack *s) {
    if(s->sp >= STACK_SIZE) {
        syyerror("Compiler error! Stack underflow!");
        exit(EXIT_FAILURE);
    }
    return s->values[s->sp];
}

void init_stack(stack *s) {
    s->sp = STACK_SIZE;
}

