
#ifndef DEFS_H
#define DEFS_H

typedef unsigned long long TOKENTYPE;

#define IN       &
#define bool     int
#define TRUE     1
#define FALSE    0

#define NONE           0x0            
#define _EOF           0x1            
#define _PROGRAM       0x2            
#define _VAR           0x4            
#define _PROC          0x8            
#define _SEMICOLON     0x10        
#define _IDENTIFIER    0x20        
#define _COLON         0x40        
#define _INT           0x80        
#define _PROCEDURE     0x100        
#define _LEFT_PAR      0x200        
#define _RIGHT_PAR     0x400        
#define _BEGIN         0x800        
#define _END           0x1000        
#define _ASSIGN        0x2000        
#define _COMMA         0x4000        
#define _PLUS          0x8000        
#define _MINUS         0x10000        
#define _CONSTANT      0x20000        
#define _MULTIPLY      0x40000        
#define _DIVIDE        0x80000        
#define _IF            0x100000    
#define _THEN          0x200000    
#define _ELSE          0x400000    
#define _LT            0x800000    
#define _GT            0x1000000    
#define _LE            0x2000000    
#define _GE            0x4000000    
#define _EQ            0x8000000    
#define _NE            0x10000000
#define _WHILE         0x20000000
#define _DO            0x40000000

static char *tokens[] = { "NONE", "_EOF", "_PROGRAM", "_VAR", "_PROC", 
			  "_SEMICOLON", "_IDENTIFIER", "_COLON", "_INT", 
			  "_PROCEDURE", "_LEFT_PAR", "_RIGHT_PAR", "_BEGIN", 
			  "_END", "_ASSIGN", "_COMMA", "_PLUS", "_MINUS", 
			  "_CONSTANT", "_MULTIPLY", "_DIVIDE", "_IF", "_THEN", 
			  "_ELSE", "_LT", "_GT", "_LE", "_GE", "_EQ", "_NE", 
			  "_WHILE", "_DO" };

#endif


