
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "defs.h"

#define blank      ' '
#define tab        '\t'
#define newline    '\n'

#define get_char()       getc(stdin)
#define unget_char(c)    ungetc(c, stdin)


TOKENTYPE scanner(void);

void concat(char *name, char c);



char id[100];
int state;
int line = 1;

TOKENTYPE scanner(void) {
    char ch;
    state = 0;
    id[0] = 0; 
    while(1) {
        switch(state) {
            case 0 : {
                ch = get_char();
                if(ch == blank || ch == tab) state = 0;
                else if(ch == newline) { line++; state = 0; }
                else if(ch == ',') state = 1;
                else if(ch == ';') state = 2;
                else if(ch == '(') state = 3;
                else if(ch == ')') state = 4;
                else if(ch == '+') state = 5;
                else if(ch == '-') state = 6;
                else if(ch == '*') state = 7;
                else if(ch == '/') state = 8;
                else if(ch == ':') state = 9;
                else if(ch == '=') state = 12;
                else if(ch == '<') state = 13;
                else if(ch == '>') state = 17;
                else if(isalpha(ch)) { concat(id, ch); state = 20; }
                else if(isdigit(ch)) state = 22;
                else if(ch == '{') {
                    while((ch = get_char()) != '}') 
                        if(ch == newline) line++;
                    state = 0;
                    printf("COMMENT in line %d\n", line);
                }
                else if(ch == EOF) return _EOF;
                else {
                    printf("LEXICAL ERROR ON CHARACTER %c in line %d\n", ch, line);
                    state = 0;
                }
            }; break;
            case 1 : return _COMMA;
            case 2 : return _SEMICOLON;
            case 3 : return _LEFT_PAR;
            case 4 : return _RIGHT_PAR;
            case 5 : return _PLUS;
            case 6 : return _MINUS;
            case 7 : return _MULTIPLY;
            case 8 : return _DIVIDE;
            case 9 : {
                ch = get_char();
                if(ch == '=') state = 10;
                else state = 11;
            }; break;
            case 10 : return _ASSIGN;
            case 11 : unget_char(ch); return _COLON;
            case 12 : return _EQ;
            case 13 : {
                ch = get_char();
                if(ch == '=') state = 14;
                else if(ch == '>') state = 15;
                else state = 16;
            }; break;
            case 14 : return _LE;
            case 15 : return _NE;
            case 16 : unget_char(ch); return _LT;
            case 17 : {
                ch = get_char();
                if(ch == '=') state = 18;
                else state = 19;
            }; break;
            case 18 : return _GE;
            case 19 : unget_char(ch); return _GT;
            case 20 : {
                unsigned token;
                ch = get_char();
                concat(id, ch);    //sledeci znak
                if(isalpha(ch)) state = 20;
                else if(isdigit(ch)) state = 20;
                else state = 21;
            }; break;
            case 21 : {
                unget_char(ch);
                id[strlen(id) - 1] = 0;    //skini jedan char zbog unget_char()
                
                if(strcmp(id, "program") == 0)        return _PROGRAM;
                else if(strcmp(id, "var") == 0)       return _VAR;
                else if(strcmp(id, "procedure") == 0) return _PROC;
                else if(strcmp(id, "begin") == 0)     return _BEGIN;
                else if(strcmp(id, "end") == 0)       return _END;
                else if(strcmp(id, "if") == 0)        return _IF;
                else if(strcmp(id, "then") == 0)      return _THEN;
                else if(strcmp(id, "else") == 0)      return _ELSE;
                else if(strcmp(id, "while") == 0)     return _WHILE;
                else if(strcmp(id, "do") == 0)        return _DO;
                else if(strcmp(id, "int") == 0)       return _INT;
                else return _IDENTIFIER;
            }
            case 22 : {
                ch = get_char();
                if(isdigit(ch)) state = 22;
                else state = 23;
            }; break;
            case 23 : unget_char(ch); return _CONSTANT;
        }
    }
}



void concat(char *name, char c) {
    char s[2];
    s[0] = c;
    s[1] = 0;
    name = strcat(name, s);
}

