%{
#define YYSTYPE char*

#include <ctype.h>
#include <string.h>
#include "y.tab.h"

int line = 1;
extern YYSTYPE yylval;
%}

ws                  [ \t]+
capital_letter      [A-Z]
small_letter        [a-z]

word                {small_letter}+
capital_word        {capital_letter}{small_letter}*


%%

{ws}                { /* skip */ }

"."                 { return _DOT; }
{capital_word}      { yylval = strdup(yytext); return _CAPITAL_WORD; }
{word}              { yylval = strdup(yytext); return _WORD; }
                      
"\n"                { line++; }    
.                   { printf("\nLEXICAL ERROR on character %c in line %d", 
                              yytext[0], line); }    

%%

int yywrap() {
    return 1;
}
