/* Parser koji broji reci i recenice */

%{
#include <stdio.h>
#include <stdlib.h>

#define YYSTYPE char*

int yylex(void);
int yyparse(void);

extern int line;
int word_counter = 0;
int sentence_counter = 0;
%}

%token    _DOT
%token    _CAPITAL_WORD
%token    _WORD


%%

text 
    :    /* empty text */
    |    text sentence
    ;
          
sentence 
    :    _CAPITAL_WORD words _DOT
            {   word_counter++;
                sentence_counter++;
                free($1); }
    ;

words 
    :    /* empty */
    |    words _WORD
            {   word_counter++; 
                free($2); }
            
    |    words _CAPITAL_WORD    
            {   word_counter++;
	        free($2); }
    ;


%%

int main() {
    printf("\nSTART\n");
    yyparse();
    printf("\nTotal words: %d.", word_counter);
    printf("\nTotal sentences: %d.\n", sentence_counter);
    printf("\nSTOP\n");
    return 0;
}


int yyerror(char *s) {
    fprintf(stderr, "\nSYNTAX ERROR in line %d: %s", line, s);
    return 0;
} 
